
///////////////////////////////////////////////////////////////////////////
//
//		Realistic rain real-time simulation program
//
//		Pierre Rousseau
//
///////////////////////////////////////////////////////////////////////////
//
//		Texture cameras handling
//
///////////////////////////////////////////////////////////////////////////



#include "RainTextureFrameListener.h"




TextureFrameListener::TextureFrameListener(SceneManager* SceneMgr) : RenderTargetListener()
{
    mSceneMgr=SceneMgr;
}

void TextureFrameListener::preRenderTargetUpdate (const Ogre::RenderTargetEvent &evt)
{
    mSceneMgr->getStaticGeometry(STATIC_GEOMETRY_NAME)->setVisible(false);
}

void TextureFrameListener::postRenderTargetUpdate (const Ogre::RenderTargetEvent &evt)
{
    mSceneMgr->getStaticGeometry(STATIC_GEOMETRY_NAME)->setVisible(true);
}


